package gov.usgs.earthquake.nshmp.gmm;

import static gov.usgs.earthquake.nshmp.gmm.Gmm.MA_05;

import java.io.IOException;
import java.util.EnumSet;
import java.util.Set;
import java.util.stream.Stream;

import org.junit.jupiter.api.extension.ExtensionContext;
import org.junit.jupiter.params.ParameterizedTest;
import org.junit.jupiter.params.provider.Arguments;
import org.junit.jupiter.params.provider.ArgumentsProvider;
import org.junit.jupiter.params.provider.ArgumentsSource;

public class MotazedianAtkinson_2005_tests implements ArgumentsProvider {

  private static String GMM_INPUTS = "/gmm/motazedian-atkinson-2005-inputs.csv";
  private static String GMM_RESULTS = "/gmm/motazedian-atkinson-2005-results.csv";

  @ParameterizedTest(name = "({index}) {0} {2} {1}")
  @ArgumentsSource(MotazedianAtkinson_2005_tests.class)
  void test(int index, Gmm gmm, Imt imt, double exMedian, double exSigma, String inputs) {
    GmmTest.test(index, gmm, imt, exMedian, exSigma, inputs);
  }

  @Override
  public Stream<? extends Arguments> provideArguments(ExtensionContext context) throws Exception {
    return GmmTest.loadResults(GMM_RESULTS, GMM_INPUTS);
  }

  /* Result generation sets */
  private static Set<Gmm> gmms = EnumSet.of(
      MA_05);

  // private static Set<Imt> imts = Imt.mprsImts();
  private static Set<Imt> imts = MotazedianAtkinson_2005.COEFFS_MPRS.imts();
  // private static Set<Imt> imts =
  // MotazedianAtkinson_2005.COEFFS_INTERP.imts();
  // private static Set<Imt> imts = EnumSet.of(SA0P02);

  public static void main(String[] args) throws IOException {
    // for (Imt imt : imts) {
    // System.out.println(imt);
    // }
    GmmTest.generateResults(gmms, imts, GMM_INPUTS, GMM_RESULTS);
    System.out.println("Done");
  }
}
